Add LSB headers to the Debian init.d script
[asterisk/asterisk.git] / contrib / init.d / rc.debian.asterisk
1 #! /bin/sh
2 # $Id$
3 #
4 # Mon Jun 04 2007 IƱaki Baz Castillo <ibc@in.ilimit.es>
5 # - Eliminated SAFE_ASTERISK since it doesn't work as LSB script (it could require a independent "safe_asterisk" init script).
6 # - Load and use the standar "/lib/lsb/init-functions".
7 # - Added "--oknodo" to "start-stop-daemon" for compatibility with LSB:
8 #   http://www.linux-foundation.org/spec/refspecs/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
9 #
10 # Thu Nov 17 2005 Gregory Boehnlein <damin@nacs.net>
11 # - Reversed behavior of LD_ASSUME_KERNEL=2.4.1
12 # - Added detailed failure messages
13 #
14 # Sun Jul 18 2004 Gregory Boehnlein <damin@nacs.net>
15 # - Added test for safe_asterisk
16 # - Changed "stop gracefully" to "stop now"
17 # - Added support for -U and -G command line options
18 # - Modified "reload" to call asterisk -rx 'reload' 
19
20 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
21 NAME=asterisk
22 DESC="Asterisk PBX"
23 # Full path to asterisk binary
24 DAEMON=__ASTERISK_SBIN_DIR__/asterisk
25 ASTVARRUNDIR=__ASTERISK_VARRUN_DIR__
26 ASTETCDIR=__ASTERISK_ETC_DIR__
27 TRUE=/bin/true
28
29 ### BEGIN INIT INFO
30 # Provides:             asterisk
31 # Required-Start:       $local_fs
32 # Required-Stop:        $local_fs
33 # Should-Start:         dahdi mysql postgresql
34 # Should-Stop:
35 # Default-Start:        2 3 4 5
36 # Default-Stop:         0 1 6
37 # Short-Description:    Asterisk PBX
38 # Description:          the Asterisk Open Source PBX
39 ### END INIT INFO
40
41 # Uncomment this ONLY if you know what you are doing.
42 # export LD_ASSUME_KERNEL=2.4.1
43
44 # Uncomment the following and set them to the user/groups that you
45 # want to run Asterisk as. NOTE: this requires substantial work to
46 # be sure that Asterisk's environment has permission to write the
47 # files required  for  its  operation, including logs, its comm
48 # socket, the asterisk database, etc.
49 #AST_USER="asterisk"
50 #AST_GROUP="asterisk"
51
52 set -e
53
54 if ! [ -x $DAEMON ] ; then
55         echo "ERROR: $DAEMON not found"
56         exit 0
57 fi
58
59 if ! [ -d $ASTETCDIR ] ; then
60         echo "ERROR: $ASTETCDIR directory not found"
61         exit 0
62 fi
63
64 # Use the LSB standar functions for services management
65 . /lib/lsb/init-functions
66
67 case "$1" in
68   start)
69         # Check if Asterisk is already running.  If it is, then bug out, because
70         # starting up Asterisk when Asterisk is already running is very bad.
71         VERSION=`${DAEMON} -rx 'core show version' || ${TRUE}`
72         if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
73                 echo "Asterisk is already running.  $0 will exit now."
74                 exit 1
75         fi
76
77         log_begin_msg "Starting $DESC: $NAME"
78         if [ ! -d $ASTVARRUNDIR ]; then
79                 mkdir -p $ASTVARRUNDIR
80         fi
81
82         if [ $AST_USER ] ; then
83                 ASTARGS="-U $AST_USER"
84                 chown $AST_USER $ASTVARRUNDIR
85         fi
86         if [ $AST_GROUP ] ; then
87                 ASTARGS="$ASTARGS -G $AST_GROUP"
88                 chgrp $AST_GROUP $ASTVARRUNDIR
89         fi
90         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already running (as LSB expects):
91         start-stop-daemon --start --oknodo --exec $DAEMON -- $ASTARGS
92         log_end_msg $?
93         ;;
94   stop)
95         log_begin_msg "Stopping $DESC: $NAME"
96         # "start-stop-daemon --oknodo" returns 0 even if Asterisk was already stopped (as LSB expects):
97         start-stop-daemon --stop --oknodo --exec $DAEMON
98         log_end_msg $?
99         ;;
100   reload)
101         echo "Reloading $DESC configuration files."
102         $DAEMON -rx 'module reload' > /dev/null 2> /dev/null
103         ;;
104   restart|force-reload)
105         $0 stop
106         sleep 2  # It needs some time to really be stopped.
107         $0 start
108         # "restart|force-reload" starts Asterisk and returns 0 even if Asterisk was stopped (as LSB expects).
109         ;;
110   *)
111         N=/etc/init.d/$NAME
112         echo "Usage: $N {start|stop|restart|reload|force-reload}" >&2
113         exit 1
114         ;;
115 esac